package com.ims.studentManager;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.stream.Collectors;

import javax.annotation.PostConstruct;

import org.springframework.stereotype.Component;
import org.springframework.util.ResourceUtils;

@Component
public class StudentManagerHelp {
	
	private String help;

	@PostConstruct
	public void init() {
		try {
			// @formatter:off
			help = "Sintaxis: java -jar movieadvisor.jar [OPCIONES]\r\n"
					+ "\r\n"
					+ "	-lg\r\n"
					+ "	Lista los diferentes alumnos del instituto.\r\n"
					+ "	No se pueden utilizar más parámetros.\r\n"
					+ "	\r\n"
					+ "	-ag genero1,genero2,genero...\r\n"
					+ "	Lista aquellas películas que pertenecen a al menos uno de los géneros \r\n"
					+ "	que se indican.	El listado de géneros no puede incluir espacios.\r\n"
					+ "	\r\n"
					+ "	-tg genero1,genero2,genero...\r\n"
					+ "	Lista aquellas películas que pertenecen a todos y cada uno de los \r\n"
					+ "	géneros que se 	indican. El listado de géneros no puede incluir espacios. \r\n"
					+ "	\r\n"
					+ "	-y año\r\n"
					+ "	Lista aquellas películas que se estrenaron en el año indicado.\r\n"
					+ "	El año debe expresarse con 4 cifras.\r\n"
					+ "	\r\n"
					+ "	-b desde,hasta\r\n"
					+ "	Lista aquellas películas que se estrenaron entre los años DESDE y HASTA.\r\n"
					+ "	Los años indicados están incluidos. Deben expresarse con 4 cifras.\r\n"
					+ "	\r\n"
					+ "	-t titulo\r\n"
					+ "	Lista aquellas películas cuyo título contiene la cadena proporcionada.\r\n"
					+ "	Se ignorará el uso de mayúsculas/minúsculas en la comparación.\r\n"
					+ "	\r\n"
					+ "	-h\r\n"
					+ "	Muestra este mensaje de ayuda.\r\n"
					+ "	\r\n"
					+ "EJEMPLOS DE USO\r\n"
					+ "\r\n"
					+ "java -jar movieadvisor.jar -y 2018 -ag Action,Comedy\r\n"
					+ "Muestra las películas estrenadas de 2018 de acción y/o de comedia.\r\n"
					+ "\r\n"
					+ "java -jar movieadvisor.jar -t heart\r\n"
					+ "Muestra las películas cuyo título contiene la palabra heart.\r\n"
					+ "\r\n"
					+ "java -jar movieadvisor.jar -td Action,Sci-Fi -b 1990,2010 -t star\r\n"
					+ "Muestra las películas cuyo título contiene la palabra star, pertenecen al \r\n"
					+ "género de acción y ciencia ficción y fueron estrenadas entre 1990 y 2010.   \r\n"
					+ "\r\n"
					+ "java -jar movieadvisor.jar -lg\r\n"
					+ "Muestra un listado con todos los géneros.\r\n"
					+ "\r\n"
					+ "\r\n"
					+ "LICENCIAS\r\n"
					+ "\r\n"
					+ "Los datos utilizados sobre películas utilizados en este ejemplo son\r\n"
					+ "reales y están sacados del sitio web www.imdb.com. Ten en cuenta\r\n"
					+ "que solo puede ser usada con fines personales y no comerciales.";
			// @formatter:on

		} catch (IOException e) {
			System.err.println("Error cargando el texto de ayuda");
			System.exit(-1);
		}
	}

	public String getHelp() {
		return help;
	}
	
}
