package com.ims.studentManager.dao;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.ims.studentManager.ConfigPackage.AppConfig;
import com.ims.studentManger.Package.Student;

@Repository
public class StudentDaoImplMemory implements StudentDao{

	public List<Student> students = new ArrayList<>();
	
	@Autowired
	private AppConfig appConfig;
	
	public void init() {
		students = UtilStudentFileReader.readFile(appConfig.getFile(),appConfig.getSeparator(),appConfig.getListSeparator());
	}
	
	public Student findById(long id) {
		
		// @formatter:off
 
		Optional<Student> result = students
				.stream()
				.filter(f -> f.getId() == id)
				.findFirst();
		
		// @formatter:on

		
		return result.orElse(null);
	}

	public Collection<Student> findAll() {
		return students;
	}

	public void insert(Student student) {
		students.add(student);
		
	}

	public void edit(Student student) {
		int index = getIndexOf(student.getId());
		if(index != -1)
			students.set(index, student);
	}

	public void delete(long id) {
		int index = getIndexOf(id);
		if(index != -1)
			students.remove(index);
	}

	private int getIndexOf(long id) {
		boolean encontrado = false;
		int index = 0;
		
		while(!encontrado && index < students.size()) {
			if(students.get(index).getId() == id)
				encontrado = true;
			else
				index++;
		}
		return (encontrado) ? index : -1;
	}
	
}
