package com.ims.studentManager.dao;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.util.ResourceUtils;

import com.ims.studentManger.Package.Student;

public class UtilStudentFileReader {

	public static List<Student> readFile(final String path,final String separator,final String listSeparator) {
		List<Student> result = new ArrayList<>();
		
		//@formatter:off
		try {
			result = Files.lines(Paths.get(ResourceUtils.getFile(path).toURI()))
				.skip(1)
				.map(line -> {
					
					String[] values = line.split(separator);
					return new Student(Long.parseLong(values[0]),values[1],values[2],
							Arrays.asList(values[3].split(listSeparator)));
					
				}).collect(Collectors.toList());
	
		} catch (IOException e) {
			System.out.println("Error en la lectura de datos del fichero");
			e.printStackTrace();
		}
		//@formatter:on
		
		return result;
	}
	
}
