package com.ims.studentManager.service;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ims.studentManager.dao.StudentDao;
import com.ims.studentManger.Package.Student;

@Service
public class StudentService {
	@Autowired
	StudentDao studentDao;

	@Autowired
	StudentQueryService queryService;

	public Collection<String> findAllMarks() {
		List<String> result = null;

		// @formatter:off
		result = studentDao.findAll()
				.stream()
				.map(f -> f.getMarks())
				.flatMap(lista -> lista.stream())
				.distinct()
				.sorted()
				.collect(Collectors.toList());

		// @formatter:on

		return result;
	}

	public Collection<Student> findByAnyMark(String... marks) {

		return queryService.anyMark(marks).exec();

	}

	public Collection<Student> findByAllMarks(String... marks) {
		return queryService.allMarks(marks).exec();
	}
	
	

	public Collection<Student> findByGrade(String grade) {
		return queryService.grade(grade).exec();
	}

	public Collection<Student> findBetweenYears(float max, float min) {
		return queryService.betweenAvgMark(max, min).exec();
	}

	public Collection<Student> findByNameContains(String title) {
		return queryService.nameContains(title).exec();
	}

	public Collection<Student> findAll() {
		return studentDao.findAll();
	}
}
